#pragma once 

#include "mbed.h"
#include "Pipe.h"

#define _SerialPipeBase SerialBase

class SerialPipe : public _SerialPipeBase
{
public:
    SerialPipe(PinName tx, PinName rx, int rxSize = 128, int txSize = 128);
#if DEVICE_SERIAL_FC
    SerialPipe(PinName tx, PinName rx, PinName rts, PinName cts, int rxSize = 128, int txSize = 128);
#endif
    virtual ~SerialPipe(void);
    // tx channel
    int writeable(void);
    int putc(int c); // blocking
    int put(const void* buffer, int length, bool blocking);
    // rx channel
    int readable(void);
    int getc(void); // blocking
    int get(void* buffer, int length, bool blocking);
protected:
    void rxIrqBuf(void);
    void txIrqBuf(void);
    void txStart(void);
    Pipe<char> _pipeRx;
    Pipe<char> _pipeTx;
};
